/**
 * DevExtreme (cjs/__internal/scheduler/r1/utils/index.js)
 * Version: 23.2.7 (build 24210-0111)
 * Build date: Sun Jul 28 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.agendaUtils = void 0;
Object.defineProperty(exports, "calculateCellIndex", {
    enumerable: true,
    get: function() {
        return _base.calculateCellIndex
    }
});
Object.defineProperty(exports, "calculateDayDuration", {
    enumerable: true,
    get: function() {
        return _base.calculateDayDuration
    }
});
Object.defineProperty(exports, "calculateIsGroupedAllDayPanel", {
    enumerable: true,
    get: function() {
        return _base.calculateIsGroupedAllDayPanel
    }
});
Object.defineProperty(exports, "calculateViewStartDate", {
    enumerable: true,
    get: function() {
        return _base.calculateViewStartDate
    }
});
exports.dayUtils = void 0;
Object.defineProperty(exports, "excludeFromRecurrence", {
    enumerable: true,
    get: function() {
        return _exclude_from_recurrence.excludeFromRecurrence
    }
});
Object.defineProperty(exports, "extendGroupItemsForGroupingByDate", {
    enumerable: true,
    get: function() {
        return _base.extendGroupItemsForGroupingByDate
    }
});
Object.defineProperty(exports, "formatWeekday", {
    enumerable: true,
    get: function() {
        return _format_weekday.formatWeekday
    }
});
Object.defineProperty(exports, "formatWeekdayAndDay", {
    enumerable: true,
    get: function() {
        return _format_weekday.formatWeekdayAndDay
    }
});
Object.defineProperty(exports, "getAppointmentKey", {
    enumerable: true,
    get: function() {
        return _base.getAppointmentKey
    }
});
Object.defineProperty(exports, "getAppointmentRenderingStrategyName", {
    enumerable: true,
    get: function() {
        return _base.getAppointmentRenderingStrategyName
    }
});
Object.defineProperty(exports, "getAppointmentTakesAllDay", {
    enumerable: true,
    get: function() {
        return _base.getAppointmentTakesAllDay
    }
});
Object.defineProperty(exports, "getCalculatedFirstDayOfWeek", {
    enumerable: true,
    get: function() {
        return _base.getCalculatedFirstDayOfWeek
    }
});
Object.defineProperty(exports, "getCellDuration", {
    enumerable: true,
    get: function() {
        return _base.getCellDuration
    }
});
Object.defineProperty(exports, "getDatesWithoutTime", {
    enumerable: true,
    get: function() {
        return _base.getDatesWithoutTime
    }
});
Object.defineProperty(exports, "getDisplayedCellCount", {
    enumerable: true,
    get: function() {
        return _base.getDisplayedCellCount
    }
});
Object.defineProperty(exports, "getDisplayedRowCount", {
    enumerable: true,
    get: function() {
        return _base.getDisplayedRowCount
    }
});
Object.defineProperty(exports, "getGroupCount", {
    enumerable: true,
    get: function() {
        return _base.getGroupCount
    }
});
Object.defineProperty(exports, "getGroupPanelData", {
    enumerable: true,
    get: function() {
        return _base.getGroupPanelData
    }
});
Object.defineProperty(exports, "getHeaderCellText", {
    enumerable: true,
    get: function() {
        return _base.getHeaderCellText
    }
});
Object.defineProperty(exports, "getHorizontalGroupCount", {
    enumerable: true,
    get: function() {
        return _base.getHorizontalGroupCount
    }
});
Object.defineProperty(exports, "getIsGroupedAllDayPanel", {
    enumerable: true,
    get: function() {
        return _base.getIsGroupedAllDayPanel
    }
});
Object.defineProperty(exports, "getKeyByGroup", {
    enumerable: true,
    get: function() {
        return _base.getKeyByGroup
    }
});
Object.defineProperty(exports, "getOverflowIndicatorColor", {
    enumerable: true,
    get: function() {
        return _base.getOverflowIndicatorColor
    }
});
Object.defineProperty(exports, "getPreparedDataItems", {
    enumerable: true,
    get: function() {
        return _data.getPreparedDataItems
    }
});
Object.defineProperty(exports, "getSkippedHoursInRange", {
    enumerable: true,
    get: function() {
        return _base.getSkippedHoursInRange
    }
});
Object.defineProperty(exports, "getStartViewDateTimeOffset", {
    enumerable: true,
    get: function() {
        return _base.getStartViewDateTimeOffset
    }
});
Object.defineProperty(exports, "getStartViewDateWithoutDST", {
    enumerable: true,
    get: function() {
        return _base.getStartViewDateWithoutDST
    }
});
Object.defineProperty(exports, "getToday", {
    enumerable: true,
    get: function() {
        return _base.getToday
    }
});
Object.defineProperty(exports, "getTotalCellCountByCompleteData", {
    enumerable: true,
    get: function() {
        return _base.getTotalCellCountByCompleteData
    }
});
Object.defineProperty(exports, "getTotalRowCountByCompleteData", {
    enumerable: true,
    get: function() {
        return _base.getTotalRowCountByCompleteData
    }
});
Object.defineProperty(exports, "getValidCellDateForLocalTimeFormat", {
    enumerable: true,
    get: function() {
        return _base.getValidCellDateForLocalTimeFormat
    }
});
Object.defineProperty(exports, "getVerticalGroupCountClass", {
    enumerable: true,
    get: function() {
        return _base.getVerticalGroupCountClass
    }
});
Object.defineProperty(exports, "getViewStartByOptions", {
    enumerable: true,
    get: function() {
        return _base.getViewStartByOptions
    }
});
Object.defineProperty(exports, "getWeekendsCount", {
    enumerable: true,
    get: function() {
        return _base.getWeekendsCount
    }
});
Object.defineProperty(exports, "hasResourceValue", {
    enumerable: true,
    get: function() {
        return _base.hasResourceValue
    }
});
Object.defineProperty(exports, "isDataOnWeekend", {
    enumerable: true,
    get: function() {
        return _base.isDataOnWeekend
    }
});
Object.defineProperty(exports, "isDateAndTimeView", {
    enumerable: true,
    get: function() {
        return _base.isDateAndTimeView
    }
});
Object.defineProperty(exports, "isDateInRange", {
    enumerable: true,
    get: function() {
        return _base.isDateInRange
    }
});
Object.defineProperty(exports, "isFirstCellInMonthWithIntervalCount", {
    enumerable: true,
    get: function() {
        return _base.isFirstCellInMonthWithIntervalCount
    }
});
Object.defineProperty(exports, "isGroupingByDate", {
    enumerable: true,
    get: function() {
        return _base.isGroupingByDate
    }
});
Object.defineProperty(exports, "isHorizontalGroupingApplied", {
    enumerable: true,
    get: function() {
        return _base.isHorizontalGroupingApplied
    }
});
Object.defineProperty(exports, "isHorizontalView", {
    enumerable: true,
    get: function() {
        return _base.isHorizontalView
    }
});
Object.defineProperty(exports, "isTimelineView", {
    enumerable: true,
    get: function() {
        return _base.isTimelineView
    }
});
Object.defineProperty(exports, "isVerticalGroupingApplied", {
    enumerable: true,
    get: function() {
        return _base.isVerticalGroupingApplied
    }
});
exports.renderUtils = exports.monthUtils = void 0;
Object.defineProperty(exports, "setOptionHour", {
    enumerable: true,
    get: function() {
        return _base.setOptionHour
    }
});
Object.defineProperty(exports, "splitNumber", {
    enumerable: true,
    get: function() {
        return _base.splitNumber
    }
});
exports.workWeekUtils = exports.weekUtils = exports.viewsUtils = exports.timelineWeekUtils = exports.timelineMonthUtils = exports.themeUtils = void 0;
var _themes = require("../../../scheduler/r1/utils/themes");
var _agenda = require("./agenda");
var _day = require("./day");
var _month = require("./month");
var _render = require("./render");
var _timeline_month = require("./timeline_month");
var _timeline_week = require("./timeline_week");
var _views = require("./views");
var _week = require("./week");
var _work_week = require("./work_week");
var _base = require("./base");
var _data = require("./data");
var _exclude_from_recurrence = require("./exclude_from_recurrence");
var _format_weekday = require("./format_weekday");
const agendaUtils = {
    calculateStartViewDate: _agenda.calculateStartViewDate
};
exports.agendaUtils = agendaUtils;
const dayUtils = {
    calculateStartViewDate: _day.calculateStartViewDate
};
exports.dayUtils = dayUtils;
const weekUtils = {
    getIntervalDuration: _week.getIntervalDuration,
    getTimePanelCellText: _week.getTimePanelCellText,
    calculateStartViewDate: _week.calculateStartViewDate,
    calculateViewStartDate: _week.calculateViewStartDate
};
exports.weekUtils = weekUtils;
const workWeekUtils = {
    calculateStartViewDate: _work_week.calculateStartViewDate
};
exports.workWeekUtils = workWeekUtils;
const monthUtils = {
    getViewStartByOptions: _month.getViewStartByOptions,
    getCellText: _month.getCellText,
    calculateCellIndex: _month.calculateCellIndex,
    calculateStartViewDate: _month.calculateStartViewDate
};
exports.monthUtils = monthUtils;
const timelineWeekUtils = {
    getDateForHeaderText: _timeline_week.getDateForHeaderText
};
exports.timelineWeekUtils = timelineWeekUtils;
const timelineMonthUtils = {
    calculateStartViewDate: _timeline_month.calculateStartViewDate
};
exports.timelineMonthUtils = timelineMonthUtils;
const viewsUtils = {
    getCurrentView: _views.getCurrentView
};
exports.viewsUtils = viewsUtils;
const renderUtils = {
    addToStyles: _render.addToStyles,
    addWidthToStyle: _render.addWidthToStyle,
    addHeightToStyle: _render.addHeightToStyle,
    getGroupCellClasses: _render.getGroupCellClasses,
    combineClasses: _render.combineClasses,
    getCellSizeHorizontalClass: _render.getCellSizeHorizontalClass,
    getCellSizeVerticalClass: _render.getCellSizeVerticalClass
};
exports.renderUtils = renderUtils;
const themeUtils = {
    getThemeType: _themes.getThemeType
};
exports.themeUtils = themeUtils;
