/**
 * DevExtreme (cjs/__internal/ui/m_validation_group.js)
 * Version: 23.2.7 (build 24210-0111)
 * Build date: Sun Jul 28 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _component_registrator = _interopRequireDefault(require("../../core/component_registrator"));
var _dom_component = _interopRequireDefault(require("../../core/dom_component"));
var _renderer = _interopRequireDefault(require("../../core/renderer"));
var _m_validation_engine = _interopRequireDefault(require("./m_validation_engine"));
var _m_validation_summary = _interopRequireDefault(require("./m_validation_summary"));
var _m_validator = _interopRequireDefault(require("./m_validator"));

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
const VALIDATION_ENGINE_CLASS = "dx-validationgroup";
const VALIDATOR_CLASS = "dx-validator";
const VALIDATION_SUMMARY_CLASS = "dx-validationsummary";
let ValidationGroup = function(_DOMComponent) {
    _inheritsLoose(ValidationGroup, _DOMComponent);

    function ValidationGroup() {
        return _DOMComponent.apply(this, arguments) || this
    }
    var _proto = ValidationGroup.prototype;
    _proto._getDefaultOptions = function() {
        return _DOMComponent.prototype._getDefaultOptions.call(this)
    };
    _proto._init = function() {
        _DOMComponent.prototype._init.call(this);
        _m_validation_engine.default.addGroup(this, false)
    };
    _proto._initMarkup = function() {
        const $element = this.$element();
        $element.addClass("dx-validationgroup");
        $element.find(".".concat("dx-validator")).each((_, validatorContainer) => {
            _m_validator.default.getInstance((0, _renderer.default)(validatorContainer))._initGroupRegistration()
        });
        $element.find(".".concat("dx-validationsummary")).each((_, summaryContainer) => {
            _m_validation_summary.default.getInstance((0, _renderer.default)(summaryContainer)).refreshValidationGroup()
        });
        _DOMComponent.prototype._initMarkup.call(this)
    };
    _proto.validate = function() {
        return _m_validation_engine.default.validateGroup(this)
    };
    _proto.reset = function() {
        return _m_validation_engine.default.resetGroup(this)
    };
    _proto._dispose = function() {
        _m_validation_engine.default.removeGroup(this);
        this.$element().removeClass("dx-validationgroup");
        _DOMComponent.prototype._dispose.call(this)
    };
    _proto._useTemplates = function() {
        return false
    };
    return ValidationGroup
}(_dom_component.default);
(0, _component_registrator.default)("dxValidationGroup", ValidationGroup);
var _default = ValidationGroup;
exports.default = _default;
